--- old/usr/src/lib/libc/port/locale/euc.c	Tue May 20 07:58:46 2014
+++ new/usr/src/lib/libc/port/locale/euc.c	Tue May 20 07:58:46 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins. All rights reserved.
  * Copyright (c) 1993
@@ -40,8 +41,8 @@
 #include <wchar.h>
 #include <sys/types.h>
 #include <sys/euc.h>
-#include "runetype.h"
 #include "mblocal.h"
+#include "lctype.h"
 
 static size_t	_EUC_mbrtowc_impl(wchar_t *_RESTRICT_KYWD,
     const char *_RESTRICT_KYWD,
@@ -61,6 +62,7 @@
 static size_t	_EUC_TW_mbrtowc(wchar_t *_RESTRICT_KYWD,
 		    const char *_RESTRICT_KYWD,
 		    size_t, mbstate_t *_RESTRICT_KYWD);
+
 static size_t	_EUC_CN_wcrtomb(char *_RESTRICT_KYWD, wchar_t,
 		    mbstate_t *_RESTRICT_KYWD);
 static size_t	_EUC_JP_wcrtomb(char *_RESTRICT_KYWD, wchar_t,
@@ -69,6 +71,33 @@
 		    mbstate_t *_RESTRICT_KYWD);
 static size_t	_EUC_TW_wcrtomb(char *_RESTRICT_KYWD, wchar_t,
 		    mbstate_t *_RESTRICT_KYWD);
+
+static size_t	_EUC_CN_mbsnrtowcs(wchar_t *_RESTRICT_KYWD,
+		    const char **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_EUC_JP_mbsnrtowcs(wchar_t *_RESTRICT_KYWD,
+		    const char **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_EUC_KR_mbsnrtowcs(wchar_t *_RESTRICT_KYWD,
+		    const char **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_EUC_TW_mbsnrtowcs(wchar_t *_RESTRICT_KYWD,
+		    const char **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+
+static size_t	_EUC_CN_wcsnrtombs(char *_RESTRICT_KYWD,
+		    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_EUC_JP_wcsnrtombs(char *_RESTRICT_KYWD,
+		    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_EUC_KR_wcsnrtombs(char *_RESTRICT_KYWD,
+		    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_EUC_TW_wcsnrtombs(char *_RESTRICT_KYWD,
+		    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+
 static int	_EUC_mbsinit(const mbstate_t *);
 
 typedef struct {
@@ -77,7 +106,7 @@
 	int	want;
 } _EucState;
 
-static int
+int
 _EUC_mbsinit(const mbstate_t *ps)
 {
 
@@ -87,18 +116,17 @@
 /*
  * EUC-CN uses CS0, CS1 and CS2 (4 bytes).
  */
-int
-_EUC_CN_init(_RuneLocale *rl)
+void
+_EUC_CN_init(struct lc_ctype *lct)
 {
-	__mbrtowc = _EUC_CN_mbrtowc;
-	__wcrtomb = _EUC_CN_wcrtomb;
-	__mbsinit = _EUC_mbsinit;
+	lct->lc_mbrtowc = _EUC_CN_mbrtowc;
+	lct->lc_wcrtomb = _EUC_CN_wcrtomb;
+	lct->lc_mbsnrtowcs = _EUC_CN_mbsnrtowcs;
+	lct->lc_wcsnrtombs = _EUC_CN_wcsnrtombs;
+	lct->lc_mbsinit = _EUC_mbsinit;
 
-	_CurrentRuneLocale = rl;
-
-	__ctype[520] = 4;
-	charset_is_ascii = 0;
-	return (0);
+	lct->lc_max_mblen = 4;
+	lct->lc_is_ascii = 0;
 }
 
 static size_t
@@ -109,6 +137,14 @@
 }
 
 static size_t
+_EUC_CN_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst,
+    const char **_RESTRICT_KYWD src,
+    size_t nms, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__mbsnrtowcs_std(dst, src, nms, len, ps, _EUC_CN_mbrtowc));
+}
+
+static size_t
 _EUC_CN_wcrtomb(char *_RESTRICT_KYWD s, wchar_t wc,
     mbstate_t *_RESTRICT_KYWD ps)
 {
@@ -115,21 +151,27 @@
 	return (_EUC_wcrtomb_impl(s, wc, ps, SS2, 4, 0, 0));
 }
 
+static size_t
+_EUC_CN_wcsnrtombs(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+	size_t nwc, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__wcsnrtombs_std(dst, src, nwc, len, ps, _EUC_CN_wcrtomb));
+}
+
 /*
  * EUC-KR uses only CS0 and CS1.
  */
-int
-_EUC_KR_init(_RuneLocale *rl)
+void
+_EUC_KR_init(struct lc_ctype *lct)
 {
-	__mbrtowc = _EUC_KR_mbrtowc;
-	__wcrtomb = _EUC_KR_wcrtomb;
-	__mbsinit = _EUC_mbsinit;
+	lct->lc_mbrtowc = _EUC_KR_mbrtowc;
+	lct->lc_wcrtomb = _EUC_KR_wcrtomb;
+	lct->lc_mbsnrtowcs = _EUC_KR_mbsnrtowcs;
+	lct->lc_wcsnrtombs = _EUC_KR_wcsnrtombs;
+	lct->lc_mbsinit = _EUC_mbsinit;
 
-	_CurrentRuneLocale = rl;
-
-	__ctype[520] = 2;
-	charset_is_ascii = 0;
-	return (0);
+	lct->lc_max_mblen = 2;
+	lct->lc_is_ascii = 0;
 }
 
 static size_t
@@ -140,27 +182,41 @@
 }
 
 static size_t
+_EUC_KR_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst,
+    const char **_RESTRICT_KYWD src,
+    size_t nms, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__mbsnrtowcs_std(dst, src, nms, len, ps, _EUC_KR_mbrtowc));
+}
+
+static size_t
 _EUC_KR_wcrtomb(char *_RESTRICT_KYWD s, wchar_t wc,
-    mbstate_t *_RESTRICT_KYWD ps)
+	mbstate_t *_RESTRICT_KYWD ps)
 {
 	return (_EUC_wcrtomb_impl(s, wc, ps, 0, 0, 0, 0));
 }
 
+static size_t
+_EUC_KR_wcsnrtombs(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+	size_t nwc, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__wcsnrtombs_std(dst, src, nwc, len, ps, _EUC_KR_wcrtomb));
+}
+
 /*
  * EUC-JP uses CS0, CS1, CS2, and CS3.
  */
-int
-_EUC_JP_init(_RuneLocale *rl)
+void
+_EUC_JP_init(struct lc_ctype *lct)
 {
-	__mbrtowc = _EUC_JP_mbrtowc;
-	__wcrtomb = _EUC_JP_wcrtomb;
-	__mbsinit = _EUC_mbsinit;
+	lct->lc_mbrtowc = _EUC_JP_mbrtowc;
+	lct->lc_wcrtomb = _EUC_JP_wcrtomb;
+	lct->lc_mbsnrtowcs = _EUC_JP_mbsnrtowcs;
+	lct->lc_wcsnrtombs = _EUC_JP_wcsnrtombs;
+	lct->lc_mbsinit = _EUC_mbsinit;
 
-	_CurrentRuneLocale = rl;
-
-	__ctype[520] = 3;
-	charset_is_ascii = 0;
-	return (0);
+	lct->lc_max_mblen = 3;
+	lct->lc_is_ascii = 0;
 }
 
 static size_t
@@ -171,6 +227,14 @@
 }
 
 static size_t
+_EUC_JP_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst,
+    const char **_RESTRICT_KYWD src,
+    size_t nms, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__mbsnrtowcs_std(dst, src, nms, len, ps, _EUC_JP_mbrtowc));
+}
+
+static size_t
 _EUC_JP_wcrtomb(char *_RESTRICT_KYWD s, wchar_t wc,
     mbstate_t *_RESTRICT_KYWD ps)
 {
@@ -177,37 +241,58 @@
 	return (_EUC_wcrtomb_impl(s, wc, ps, SS2, 2, SS3, 3));
 }
 
+static size_t
+_EUC_JP_wcsnrtombs(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+	size_t nwc, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__wcsnrtombs_std(dst, src, nwc, len, ps, _EUC_JP_wcrtomb));
+}
+
 /*
  * EUC-TW uses CS0, CS1, and CS2.
  */
-int
-_EUC_TW_init(_RuneLocale *rl)
+void
+_EUC_TW_init(struct lc_ctype *lct)
 {
-	__mbrtowc = _EUC_TW_mbrtowc;
-	__wcrtomb = _EUC_TW_wcrtomb;
-	__mbsinit = _EUC_mbsinit;
+	lct->lc_mbrtowc = _EUC_TW_mbrtowc;
+	lct->lc_wcrtomb = _EUC_TW_wcrtomb;
+	lct->lc_mbsnrtowcs = _EUC_TW_mbsnrtowcs;
+	lct->lc_wcsnrtombs = _EUC_TW_wcsnrtombs;
+	lct->lc_mbsinit = _EUC_mbsinit;
 
-	_CurrentRuneLocale = rl;
-
-	__ctype[520] = 4;
-	charset_is_ascii = 0;
-	return (0);
+	lct->lc_max_mblen = 4;
+	lct->lc_is_ascii = 0;
 }
 
 static size_t
 _EUC_TW_mbrtowc(wchar_t *_RESTRICT_KYWD pwc, const char *_RESTRICT_KYWD s,
-    size_t n, mbstate_t *_RESTRICT_KYWD ps)
+	size_t n, mbstate_t *_RESTRICT_KYWD ps)
 {
 	return (_EUC_mbrtowc_impl(pwc, s, n, ps, SS2, 4, 0, 0));
 }
 
 static size_t
+_EUC_TW_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst,
+	const char **_RESTRICT_KYWD src,
+	size_t nms, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__mbsnrtowcs_std(dst, src, nms, len, ps, _EUC_TW_mbrtowc));
+}
+
+static size_t
 _EUC_TW_wcrtomb(char *_RESTRICT_KYWD s, wchar_t wc,
-    mbstate_t *_RESTRICT_KYWD ps)
+	mbstate_t *_RESTRICT_KYWD ps)
 {
 	return (_EUC_wcrtomb_impl(s, wc, ps, SS2, 4, 0, 0));
 }
 
+static size_t
+_EUC_TW_wcsnrtombs(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+	size_t nwc, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__wcsnrtombs_std(dst, src, nwc, len, ps, _EUC_TW_wcrtomb));
+}
+
 /*
  * Common EUC code.
  */
@@ -214,8 +299,8 @@
 
 static size_t
 _EUC_mbrtowc_impl(wchar_t *_RESTRICT_KYWD pwc, const char *_RESTRICT_KYWD s,
-    size_t n, mbstate_t *_RESTRICT_KYWD ps,
-    uint8_t cs2, uint8_t cs2width, uint8_t cs3, uint8_t cs3width)
+	size_t n, mbstate_t *_RESTRICT_KYWD ps,
+	uint8_t cs2, uint8_t cs2width, uint8_t cs3, uint8_t cs3width)
 {
 	_EucState *es;
 	int i, want;
--- old/usr/src/lib/libc/port/locale/fgetwc.c	Tue May 20 07:58:47 2014
+++ new/usr/src/lib/libc/port/locale/fgetwc.c	Tue May 20 07:58:47 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -35,22 +36,26 @@
 #include <wchar.h>
 #include "mblocal.h"
 #include "stdiom.h"
+#include "localeimpl.h"
+#include "lctype.h"
 
 /*
  * Non-MT-safe version.
  */
 wint_t
-_fgetwc_unlocked(FILE *fp)
+_fgetwc_unlocked_l(FILE *fp, locale_t loc)
 {
 	wchar_t wc;
 	size_t nconv;
 	int	c;
 	mbstate_t	*statep;
+	const struct lc_ctype *lct;
 
 	if ((c = GETC(fp)) == EOF)
 		return (WEOF);
 
-	if (MB_CUR_MAX == 1) {
+	lct = loc->ctype;
+	if (lct->lc_max_mblen == 1) {
 		/* Fast path for single-byte encodings. */
 		return ((wint_t)c);
 	}
@@ -61,7 +66,7 @@
 	}
 	do {
 		char	x = (char)c;
-		nconv = __mbrtowc(&wc, &x, 1, statep);
+		nconv = lct->lc_mbrtowc(&wc, &x, 1, statep);
 		if (nconv == (size_t)-1) {
 			break;
 		} else if (nconv == (size_t)-2) {
@@ -89,51 +94,64 @@
 	return (WEOF);
 }
 
+wint_t
+_fgetwc_unlocked(FILE *fp)
+{
+	return (_fgetwc_unlocked_l(fp, uselocale(NULL)));
+}
 
+
 /*
  * MT safe version
  */
+#undef getwc
+#pragma weak getwc = fgetwc
 wint_t
 fgetwc(FILE *fp)
 {
 	wint_t		r;
 	rmutex_t	*l;
+	locale_t	loc = uselocale(NULL);
 
 	FLOCKFILE(l, fp);
-	r = _fgetwc_unlocked(fp);
+	r = _fgetwc_unlocked_l(fp, loc);
 	FUNLOCKFILE(l);
 
 	return (r);
 }
 
-#undef	getwc
-wint_t
-getwc(FILE *fp)
-{
-	return (getwc(fp));
-}
-
 /*
  * XPG5 version.
  */
+#undef	__getwc_xpg5
+#pragma weak __getwc_xpg5 = __fgetwc_xpg5
 wint_t
 __fgetwc_xpg5(FILE *fp)
 {
 	wint_t		r;
 	rmutex_t	*l;
+	locale_t	loc = uselocale(NULL);
 
 	FLOCKFILE(l, fp);
 	if (GET_NO_MODE(fp))
 		_setorientation(fp, _WC_MODE);
-	r = _fgetwc_unlocked(fp);
+	r = _fgetwc_unlocked_l(fp, loc);
 	FUNLOCKFILE(l);
 
 	return (r);
 }
 
-#undef	__getwc_xpg5
+#pragma weak getwc_l = fgetwc_l
 wint_t
-__getwc_xpg5(FILE *fp)
+fgetwc_l(FILE *fp, locale_t loc)
 {
-	return (__fgetwc_xpg5(fp));
+	wint_t		r;
+	rmutex_t	*l;
+	FLOCKFILE(l, fp);
+	if (GET_NO_MODE(fp))
+		_setorientation(fp, _WC_MODE);
+	r = _fgetwc_unlocked_l(fp, loc);
+	FUNLOCKFILE(l);
+
+	return (r);
 }
--- old/usr/src/lib/libc/port/locale/fnmatch.c	Tue May 20 07:58:47 2014
+++ new/usr/src/lib/libc/port/locale/fnmatch.c	Tue May 20 07:58:47 2014
@@ -31,6 +31,7 @@
  */
 
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
@@ -56,8 +57,9 @@
 #include <limits.h>
 #include <string.h>
 #include <wchar.h>
+#include <xlocale.h>
 #include <wctype.h>
-
+#include "localeimpl.h"
 #include "collate.h"
 
 #define	EOS	'\0'
@@ -66,9 +68,10 @@
 #define	RANGE_NOMATCH	0
 #define	RANGE_ERROR	(-1)
 
-static int rangematch(const char *, wchar_t, int, char **, mbstate_t *);
+static int rangematch(const char *, wchar_t, int, char **, mbstate_t *,
+    locale_t);
 static int fnmatch1(const char *, const char *, const char *, int, mbstate_t,
-    mbstate_t);
+    mbstate_t, locale_t);
 
 int
 fnmatch(pattern, string, flags)
@@ -75,14 +78,16 @@
 	const char *pattern, *string;
 	int flags;
 {
+	locale_t loc = uselocale(NULL);
 	static const mbstate_t initial = { 0 };
 
-	return (fnmatch1(pattern, string, string, flags, initial, initial));
+	return (fnmatch1(pattern, string, string, flags, initial, initial,
+	    loc));
 }
 
 static int
 fnmatch1(const char *pattern, const char *string, const char *stringstart,
-    int flags, mbstate_t patmbs, mbstate_t strmbs)
+    int flags, mbstate_t patmbs, mbstate_t strmbs, locale_t loc)
 {
 	char *newp;
 	char c;
@@ -90,11 +95,11 @@
 	size_t pclen, sclen;
 
 	for (;;) {
-		pclen = mbrtowc(&pc, pattern, MB_LEN_MAX, &patmbs);
+		pclen = mbrtowc_l(&pc, pattern, MB_LEN_MAX, &patmbs, loc);
 		if (pclen == (size_t)-1 || pclen == (size_t)-2)
 			return (FNM_NOMATCH);
 		pattern += pclen;
-		sclen = mbrtowc(&sc, string, MB_LEN_MAX, &strmbs);
+		sclen = mbrtowc_l(&sc, string, MB_LEN_MAX, &strmbs, loc);
 		if (sclen == (size_t)-1 || sclen == (size_t)-2) {
 			sc = (unsigned char)*string;
 			sclen = 1;
@@ -145,10 +150,10 @@
 			/* General case, use recursion. */
 			while (sc != EOS) {
 				if (!fnmatch1(pattern, string, stringstart,
-				    flags, patmbs, strmbs))
+				    flags, patmbs, strmbs, loc))
 					return (0);
-				sclen = mbrtowc(&sc, string, MB_LEN_MAX,
-				    &strmbs);
+				sclen = mbrtowc_l(&sc, string, MB_LEN_MAX,
+				    &strmbs, loc);
 				if (sclen == (size_t)-1 ||
 				    sclen == (size_t)-2) {
 					sc = (unsigned char)*string;
@@ -172,7 +177,7 @@
 				return (FNM_NOMATCH);
 
 			switch (rangematch(pattern, sc, flags, &newp,
-			    &patmbs)) {
+			    &patmbs, loc)) {
 			case RANGE_ERROR:
 				goto norm;
 			case RANGE_MATCH:
@@ -185,8 +190,8 @@
 			break;
 		case '\\':
 			if (!(flags & FNM_NOESCAPE)) {
-				pclen = mbrtowc(&pc, pattern, MB_LEN_MAX,
-				    &patmbs);
+				pclen = mbrtowc_l(&pc, pattern, MB_LEN_MAX,
+				    &patmbs, loc);
 				if (pclen == (size_t)-1 || pclen == (size_t)-2)
 					return (FNM_NOMATCH);
 				if (pclen == 0)
@@ -200,7 +205,7 @@
 				string += sclen;
 
 			else if ((flags & FNM_IGNORECASE) &&
-			    (towlower(pc) == towlower(sc)))
+			    (towlower_l(pc, loc) == towlower_l(sc, loc)))
 				string += sclen;
 			else
 				return (FNM_NOMATCH);
@@ -212,12 +217,8 @@
 }
 
 static int
-rangematch(pattern, test, flags, newp, patmbs)
-	const char *pattern;
-	wchar_t test;
-	int flags;
-	char **newp;
-	mbstate_t *patmbs;
+rangematch(const char *pattern, wchar_t test, int flags, char **newp,
+    mbstate_t *patmbs, locale_t loc)
 {
 	int negate, ok;
 	wchar_t c, c2;
@@ -235,7 +236,7 @@
 		++pattern;
 
 	if (flags & FNM_IGNORECASE)
-		test = towlower(test);
+		test = towlower_l(test, loc);
 
 	/*
 	 * A right bracket shall lose its special meaning and represent
@@ -254,13 +255,13 @@
 			return (RANGE_NOMATCH);
 		} else if (*pattern == '\\' && !(flags & FNM_NOESCAPE))
 			pattern++;
-		pclen = mbrtowc(&c, pattern, MB_LEN_MAX, patmbs);
+		pclen = mbrtowc_l(&c, pattern, MB_LEN_MAX, patmbs, loc);
 		if (pclen == (size_t)-1 || pclen == (size_t)-2)
 			return (RANGE_NOMATCH);
 		pattern += pclen;
 
 		if (flags & FNM_IGNORECASE)
-			c = towlower(c);
+			c = towlower_l(c, loc);
 
 		if (*pattern == '-' && *(pattern + 1) != EOS &&
 		    *(pattern + 1) != ']') {
@@ -267,7 +268,8 @@
 			if (*++pattern == '\\' && !(flags & FNM_NOESCAPE))
 				if (*pattern != EOS)
 					pattern++;
-			pclen = mbrtowc(&c2, pattern, MB_LEN_MAX, patmbs);
+			pclen = mbrtowc_l(&c2, pattern, MB_LEN_MAX, patmbs,
+			    loc);
 			if (pclen == (size_t)-1 || pclen == (size_t)-2)
 				return (RANGE_NOMATCH);
 			pattern += pclen;
@@ -275,12 +277,12 @@
 				return (RANGE_ERROR);
 
 			if (flags & FNM_IGNORECASE)
-				c2 = towlower(c2);
+				c2 = towlower_l(c2, loc);
 
-			if (_collate_load_error ?
+			if (loc->collate->lc_is_posix ?
 			    c <= test && test <= c2 :
-			    _collate_range_cmp(c, test) <= 0 &&
-			    _collate_range_cmp(test, c2) <= 0)
+			    _collate_range_cmp(c, test, loc) <= 0 &&
+			    _collate_range_cmp(test, c2, loc) <= 0)
 				ok = 1;
 		} else if (c == test)
 			ok = 1;
--- old/usr/src/lib/libc/port/locale/fputwc.c	Tue May 20 07:58:47 2014
+++ new/usr/src/lib/libc/port/locale/fputwc.c	Tue May 20 07:58:47 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
  *
@@ -72,8 +73,6 @@
 	if (MB_CUR_MAX == 1 && wc > 0 && wc <= UCHAR_MAX) {
 		/*
 		 * Assume single-byte locale with no special encoding.
-		 * A more careful test would be to check
-		 * _CurrentRuneLocale->encoding.
 		 */
 		*buf = (unsigned char)wc;
 		len = 1;
--- old/usr/src/lib/libc/port/locale/gb18030.c	Tue May 20 07:58:47 2014
+++ new/usr/src/lib/libc/port/locale/gb18030.c	Tue May 20 07:58:47 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins
  * All rights reserved.
@@ -34,11 +35,11 @@
 #include "lint.h"
 #include <sys/types.h>
 #include <errno.h>
-#include "runetype.h"
 #include <stdlib.h>
 #include <string.h>
 #include <wchar.h>
 #include "mblocal.h"
+#include "lctype.h"
 
 
 static size_t	_GB18030_mbrtowc(wchar_t *_RESTRICT_KYWD,
@@ -47,24 +48,30 @@
 static int	_GB18030_mbsinit(const mbstate_t *);
 static size_t	_GB18030_wcrtomb(char *_RESTRICT_KYWD, wchar_t,
 		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_GB18030_mbsnrtowcs(wchar_t *_RESTRICT_KYWD,
+		    const char **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_GB18030_wcsnrtombs(char *_RESTRICT_KYWD,
+		    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
 
+
 typedef struct {
 	int	count;
 	uchar_t	bytes[4];
 } _GB18030State;
 
-int
-_GB18030_init(_RuneLocale *rl)
+void
+_GB18030_init(struct lc_ctype *lct)
 {
 
-	__mbrtowc = _GB18030_mbrtowc;
-	__wcrtomb = _GB18030_wcrtomb;
-	__mbsinit = _GB18030_mbsinit;
-	_CurrentRuneLocale = rl;
-	__ctype[520] = 4;
-	charset_is_ascii = 0;
-
-	return (0);
+	lct->lc_mbrtowc = _GB18030_mbrtowc;
+	lct->lc_wcrtomb = _GB18030_wcrtomb;
+	lct->lc_mbsinit = _GB18030_mbsinit;
+	lct->lc_mbsnrtowcs = _GB18030_mbsnrtowcs;
+	lct->lc_wcsnrtombs = _GB18030_wcsnrtombs;
+	lct->lc_max_mblen = 4;
+	lct->lc_is_ascii = 0;
 }
 
 static int
@@ -220,4 +227,20 @@
 ilseq:
 	errno = EILSEQ;
 	return ((size_t)-1);
+}
+
+static size_t
+_GB18030_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst,
+    const char **_RESTRICT_KYWD src, size_t nms, size_t len,
+    mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__mbsnrtowcs_std(dst, src, nms, len, ps, _GB18030_mbrtowc));
+}
+
+static size_t
+_GB18030_wcsnrtombs(char *_RESTRICT_KYWD dst,
+    const wchar_t **_RESTRICT_KYWD src, size_t nwc, size_t len,
+    mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__wcsnrtombs_std(dst, src, nwc, len, ps, _GB18030_wcrtomb));
 }
--- old/usr/src/lib/libc/port/locale/gb2312.c	Tue May 20 07:58:47 2014
+++ new/usr/src/lib/libc/port/locale/gb2312.c	Tue May 20 07:58:47 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2004 Tim J. Robbins. All rights reserved.
  * Copyright (c) 2003 David Xu <davidxu@freebsd.org>
@@ -34,6 +35,7 @@
 #include <string.h>
 #include <wchar.h>
 #include "mblocal.h"
+#include "lctype.h"
 
 static size_t	_GB2312_mbrtowc(wchar_t *_RESTRICT_KYWD,
 		    const char *_RESTRICT_KYWD,
@@ -41,23 +43,30 @@
 static int	_GB2312_mbsinit(const mbstate_t *);
 static size_t	_GB2312_wcrtomb(char *_RESTRICT_KYWD, wchar_t,
 		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_GB2312_mbsnrtowcs(wchar_t *_RESTRICT_KYWD,
+		    const char **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_GB2312_wcsnrtombs(char *_RESTRICT_KYWD,
+		    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
 
+
 typedef struct {
 	int	count;
 	uchar_t	bytes[2];
 } _GB2312State;
 
-int
-_GB2312_init(_RuneLocale *rl)
+void
+_GB2312_init(struct lc_ctype *lct)
 {
 
-	_CurrentRuneLocale = rl;
-	__mbrtowc = _GB2312_mbrtowc;
-	__wcrtomb = _GB2312_wcrtomb;
-	__mbsinit = _GB2312_mbsinit;
-	__ctype[520] = 2;
-	charset_is_ascii = 0;
-	return (0);
+	lct->lc_mbrtowc = _GB2312_mbrtowc;
+	lct->lc_wcrtomb = _GB2312_wcrtomb;
+	lct->lc_mbsinit = _GB2312_mbsinit;
+	lct->lc_mbsnrtowcs = _GB2312_mbsnrtowcs;
+	lct->lc_wcsnrtombs = _GB2312_wcsnrtombs;
+	lct->lc_max_mblen = 2;
+	lct->lc_is_ascii = 0;
 }
 
 static int
@@ -154,4 +163,20 @@
 	}
 	*s = wc & 0xff;
 	return (1);
+}
+
+static size_t
+_GB2312_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst,
+    const char **_RESTRICT_KYWD src, size_t nms, size_t len,
+    mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__mbsnrtowcs_std(dst, src, nms, len, ps, _GB2312_mbrtowc));
+}
+
+static size_t
+_GB2312_wcsnrtombs(char *_RESTRICT_KYWD dst,
+    const wchar_t **_RESTRICT_KYWD src, size_t nwc, size_t len,
+    mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__wcsnrtombs_std(dst, src, nwc, len, ps, _GB2312_wcrtomb));
 }
--- old/usr/src/lib/libc/port/locale/gbk.c	Tue May 20 07:58:47 2014
+++ new/usr/src/lib/libc/port/locale/gbk.c	Tue May 20 07:58:47 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins. All rights reserved.
  * Copyright (c) 1993
@@ -35,11 +36,11 @@
 #include "lint.h"
 #include <sys/types.h>
 #include <errno.h>
-#include "runetype.h"
 #include <stdlib.h>
 #include <string.h>
 #include <wchar.h>
 #include "mblocal.h"
+#include "lctype.h"
 
 static size_t	_GBK_mbrtowc(wchar_t *_RESTRICT_KYWD,
 		    const char *_RESTRICT_KYWD,
@@ -47,22 +48,27 @@
 static int	_GBK_mbsinit(const mbstate_t *);
 static size_t	_GBK_wcrtomb(char *_RESTRICT_KYWD, wchar_t,
 		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_GBK_mbsnrtowcs(wchar_t *_RESTRICT_KYWD,
+		    const char **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_GBK_wcsnrtombs(char *_RESTRICT_KYWD,
+		    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
 
 typedef struct {
 	wchar_t	ch;
 } _GBKState;
 
-int
-_GBK_init(_RuneLocale *rl)
+void
+_GBK_init(struct lc_ctype *lct)
 {
-
-	__mbrtowc = _GBK_mbrtowc;
-	__wcrtomb = _GBK_wcrtomb;
-	__mbsinit = _GBK_mbsinit;
-	_CurrentRuneLocale = rl;
-	__ctype[520] = 2;
-	charset_is_ascii = 0;
-	return (0);
+	lct->lc_mbrtowc = _GBK_mbrtowc;
+	lct->lc_wcrtomb = _GBK_wcrtomb;
+	lct->lc_mbsinit = _GBK_mbsinit;
+	lct->lc_mbsnrtowcs = _GBK_mbsnrtowcs;
+	lct->lc_wcsnrtombs = _GBK_wcsnrtombs;
+	lct->lc_max_mblen = 2;
+	lct->lc_is_ascii = 0;
 }
 
 static int
@@ -163,4 +169,18 @@
 	}
 	*s = wc & 0xff;
 	return (1);
+}
+
+static size_t
+_GBK_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst, const char **_RESTRICT_KYWD src,
+    size_t nms, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__mbsnrtowcs_std(dst, src, nms, len, ps, _GBK_mbrtowc));
+}
+
+static size_t
+_GBK_wcsnrtombs(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+    size_t nwc, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__wcsnrtombs_std(dst, src, nwc, len, ps, _GBK_wcrtomb));
 }
--- /dev/null	Tue May 20 07:58:47 2014
+++ new/usr/src/lib/libc/port/locale/isdigit.c	Tue May 20 07:58:47 2014
@@ -0,0 +1,91 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
+ */
+
+/*
+ * This file contains the implementation of various functional forms
+ * of the ctype tests, specifically the required by ISO C.  These are defined
+ * in the "C" (POSIX) locale.
+ */
+
+#include "lint.h"
+#include <ctype.h>
+#include <locale.h>
+#include "localeimpl.h"
+#include "_ctype.h"
+#include "lctype.h"
+
+/*
+ * We are supplying functional forms, so make sure to suppress any macros
+ * we might have imported.
+ */
+
+/*
+ * Performance note: ASCII test is *much* faster, as we can avoid expensive
+ * function call overhead.  This is the hot case, so we try to do that
+ * whenever possible.  As far as we know, *every* encoding we support
+ * is a strict superset of ASCII.  So we can make things faster by trying
+ * ASCII first, and only then falling to locale specific checks.
+ */
+
+static int
+isctype_l(int c, int mask, locale_t loc)
+{
+	return ((unsigned)c > 255 ? 0 : (loc->ctype->lc_ctype_mask[c] & mask));
+}
+
+#define	ISTYPE_L(c, mask, loc)	\
+	(isascii(c) ? (__ctype_mask[c] & (mask)) : isctype_l(c, mask, loc))
+
+#define	ISTYPE(c, mask)	ISTYPE_L(c, mask, uselocale(NULL))
+
+#define	DEFN_ISTYPE(type, mask)		\
+int					\
+is##type##_l(int c, locale_t l)	\
+{					\
+	return (ISTYPE_L(c, mask, l));	\
+}					\
+					\
+int					\
+is##type(int c)				\
+{					\
+	return (ISTYPE(c, mask));	\
+}
+
+#undef	isblank
+#undef	isupper
+#undef	islower
+#undef	isdigit
+#undef	isxdigit
+#undef	isalpha
+#undef	isalnum
+#undef	isspace
+#undef	iscntrl
+#undef	isgraph
+#undef	ispunct
+#undef	isprint
+
+DEFN_ISTYPE(blank, _ISBLANK)
+DEFN_ISTYPE(upper, _ISUPPER)
+DEFN_ISTYPE(lower, _ISLOWER)
+DEFN_ISTYPE(digit, _ISDIGIT)
+DEFN_ISTYPE(xdigit, _ISXDIGIT)
+DEFN_ISTYPE(alpha, _ISALPHA)
+DEFN_ISTYPE(alnum, _ISALNUM)
+DEFN_ISTYPE(space, _ISSPACE)
+DEFN_ISTYPE(cntrl, _ISCNTRL)
+DEFN_ISTYPE(graph, _ISGRAPH)
+DEFN_ISTYPE(punct, _ISPUNCT)
+DEFN_ISTYPE(print, _ISPRINT)
--- old/usr/src/lib/libc/port/locale/iswctype.c	Tue May 20 07:58:47 2014
+++ new/usr/src/lib/libc/port/locale/iswctype.c	Tue May 20 07:58:47 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1989, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -38,44 +39,50 @@
 
 #include "lint.h"
 #include <wctype.h>
+#include <locale.h>
 #include "runefile.h"
 #include "runetype.h"
+#include "localeimpl.h"
 #include "_ctype.h"
 
 /*
- * We removed: iswascii, iswhexnumber, and iswnumber, as
- * these are not present on Solaris.  Note that the standard requires
- * iswascii to be a macro, so it is defined in our headers.
+ * Note that the standard requires iswascii to be a macro, so it is defined
+ * in our headers.
  *
- * We renamed (per Solaris) iswideogram, iswspecial, iswspecial to the
- * equivalent values without "w".  We added a new isnumber, that looks
- * for non-ASCII numbers.
+ * We aliased (per Solaris) iswideogram, iswspecial, iswspecial to the
+ * equivalent values without "w".  The Solaris specific function isenglish()
+ * is here, but does not get an isw* equivalent.
+ *
+ * Note that various code assumes that "numbers" (iswdigit, iswxdigit)
+ * only return true for characters in the portable set.  While the assumption
+ * is not technically correct, it turns out that for all of our locales this
+ * is true.  iswhexnumber is aliased to iswxdigit.
  */
 
 static int
-__istype(wint_t c, unsigned int f)
+__istype_l(locale_t loc, wint_t c, unsigned int f)
 {
 	unsigned int rt;
 
-	/* Fast path for single byte locales */
 	if (c < 0 || c >= _CACHED_RUNES)
-		rt =  ___runetype(c);
+		rt = __runetype(loc->runelocale, c);
 	else
-		rt = _CurrentRuneLocale->__runetype[c];
+		rt = loc->runelocale->__runetype[c];
 	return (rt & f);
 }
 
 static int
-__isctype(wint_t c, unsigned int f)
+__istype(wint_t c, unsigned int f)
 {
-	unsigned int rt;
+	return (__istype_l(uselocale(NULL), c, f));
+}
 
-	/* Fast path for single byte locales */
-	if (c < 0 || c >= _CACHED_RUNES)
-		return (0);
-	else
-		rt = _CurrentRuneLocale->__runetype[c];
-	return (rt & f);
+int
+iswctype_l(wint_t wc, wctype_t class, locale_t loc)
+{
+	if (iswascii(wc))
+		return (__ctype_mask[wc] & class);
+	return (__istype_l(loc, wc, class));
 }
 
 #undef iswctype
@@ -82,134 +89,83 @@
 int
 iswctype(wint_t wc, wctype_t class)
 {
+	/*
+	 * Note that we don't just call iswctype_l because we optimize for
+	 * the iswascii() case, so that most of the time we have no need to
+	 * call uselocale().
+	 */
+	if (iswascii(wc))
+		return (__ctype_mask[wc] & class);
 	return (__istype(wc, class));
 }
 
+/*
+ * This is a legacy version, baked into binaries.
+ */
 #undef _iswctype
 unsigned
 _iswctype(wchar_t wc, int class)
 {
+	if (iswascii(wc))
+		return (__ctype_mask[wc] & class);
 	return (__istype((wint_t)wc, (unsigned int)class));
 }
 
-#undef iswalnum
-int
-iswalnum(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_A|_CTYPE_D));
+#define	DEFN_ISWTYPE(type, mask)		\
+int						\
+isw##type##_l(wint_t wc, locale_t loc)		\
+{						\
+	return (iswascii(wc) ?			\
+		(__ctype_mask[wc] & (mask)) :	\
+		__istype_l(loc, wc, mask));	\
+}						\
+						\
+int						\
+isw##type(wint_t wc)				\
+{						\
+	return (iswascii(wc) ?			\
+		(__ctype_mask[wc] & (mask)) :	\
+		__istype(wc, mask));		\
 }
 
-#undef iswalpha
-int
-iswalpha(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_A));
-}
+/* kill off any macros */
+#undef	iswalnum
+#undef	iswalpha
+#undef	iswblank
 
-#undef iswblank
-int
-iswblank(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_B));
-}
+DEFN_ISWTYPE(alnum, _CTYPE_A|_CTYPE_D)
+DEFN_ISWTYPE(alpha, _CTYPE_A)
+DEFN_ISWTYPE(blank, _CTYPE_B)
+DEFN_ISWTYPE(cntrl, _CTYPE_C)
+DEFN_ISWTYPE(digit, _CTYPE_D)
+DEFN_ISWTYPE(graph, _CTYPE_D)
+DEFN_ISWTYPE(lower, _CTYPE_L)
+DEFN_ISWTYPE(upper, _CTYPE_U)
+DEFN_ISWTYPE(print, _CTYPE_R)
+DEFN_ISWTYPE(punct, _CTYPE_P)
+DEFN_ISWTYPE(space, _CTYPE_S)
+DEFN_ISWTYPE(xdigit, _CTYPE_X)
+DEFN_ISWTYPE(ideogram, _CTYPE_I)
+DEFN_ISWTYPE(phonogram, _CTYPE_Q)
+DEFN_ISWTYPE(special, _CTYPE_T)
+DEFN_ISWTYPE(number, _CTYPE_N)
 
-#undef iswcntrl
-int
-iswcntrl(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_C));
-}
 
-#undef iswdigit
-int
-iswdigit(wint_t wc)
-{
-	return (__isctype(wc, _CTYPE_D));
-}
+#undef iswhexnumber
+#pragma weak iswhexnumber = iswxdigit
+#pragma weak iswhexnumber_l = iswxdigit_l
 
-#undef iswgraph
-int
-iswgraph(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_G));
-}
-
 #undef isideogram
-int
-isideogram(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_I));
-}
+#pragma weak isideogram = iswideogram
 
-#undef iswlower
-int
-iswlower(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_L));
-}
-
 #undef isphonogram
-int
-isphonogram(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_Q));
-}
+#pragma weak isphonogram = iswphonogram
 
-#undef iswprint
-int
-iswprint(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_R));
-}
-
-#undef iswpunct
-int
-iswpunct(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_P));
-}
-
-#undef iswspace
-int
-iswspace(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_S));
-}
-
-#undef iswupper
-int
-iswupper(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_U));
-}
-
-#undef iswxdigit
-int
-iswxdigit(wint_t wc)
-{
-	return (__isctype(wc, _CTYPE_X));
-}
-
-#undef isenglish
-int
-isenglish(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_E));
-}
-
 #undef isspecial
-int
-isspecial(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_T));
-}
+#pragma weak isspecial = iswspecial
 
 #undef isnumber
-int
-isnumber(wint_t wc)
-{
-	return (__istype(wc, _CTYPE_N));
-}
+#pragma weak isnumber = iswnumber
 
 /*
  * FreeBSD has iswrune() for use by external programs, and this is used by
@@ -228,6 +184,21 @@
 	 * ctype values differently.  We can't do that (ctype is baked into
 	 * applications), but instead can just check if *any* bit is set in
 	 * the ctype.  Any bit being set indicates its a valid rune.
+	 *
+	 * NB: For ASCII all positions except NULL are runes.
 	 */
-	return (__istype(wc, 0xffffffffU));
+	return (wc == 0 ? 0 : iswascii(wc) ? 1 : __istype(wc, 0xffffffffU));
+}
+
+/*
+ * isenglish is a Solaris legacy.  No isw* equivalent.  Note that this most
+ * likely doesn't work, as the locale data we have doesn't include it.  It
+ * specifically is only valid for non-ASCII characters.  We're not sure this
+ * is in actual use in the wild.
+ */
+#undef isenglish
+int
+isenglish(wint_t wc)
+{
+	return (__istype(wc, _CTYPE_E));
 }
